scala.reflect

# Manifest

#### trait Manifest[T] extends ClassManifest[T] with Equals

A Manifest[T] is an opaque descriptor for type T. Its supported use is to give access to the erasure of the type as a Class instance, as is necessary for the creation of native Arrays if the class is not known at compile time.

The type-relation operators <:< and =:= should be considered approximations only, as there are numerous aspects of type conformance which are not yet adequately represented in manifests.

Example usages:

      def arr[T] = new Array[T](0)                          // does not compile
      def arr[T](implicit m: Manifest[T]) = new Array[T](0) // compiles
      def arr[T: Manifest] = new Array[T](0)                // shorthand for the preceding

      // Methods manifest, classManifest, and optManifest are in [[scala.Predef]].
      def isApproxSubType[T: Manifest, U: Manifest] = manifest[T] <:< manifest[U]
      isApproxSubType[List[String], List[AnyRef]] // true
      isApproxSubType[List[String], List[Int]]    // false

      def methods[T: ClassManifest] = classManifest[T].erasure.getMethods
      def retType[T: ClassManifest](name: String) =
        methods[T] find (_.getName == name) map (_.getGenericReturnType)

      retType[Map[_, _]]("values")  // Some(scala.collection.Iterable)

Annotations
  @implicitNotFound( msg = "No Manifest available for ${T}." )
Source
  Manifest.scala

Linear Supertypes
ClassManifest[T], Equals, OptManifest[T], Serializable, Serializable, AnyRef, Any
Known Subclasses
AnyValManifest
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. Manifest
2. ClassManifest
3. Equals
4. OptManifest
5. Serializable
6. Serializable
7. AnyRef
8. Any

Visibility

1. Public
2. All

### Abstract Value Members

1. #### abstract def erasure: java.lang.Class[_]

   A class representing the type U to which T would be erased.

   A class representing the type U to which T would be erased. Note that there is no subtyping relationship between T and U.

   Definition Classes
     ClassManifest

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### def <:<(that: scala.reflect.ClassManifest[_]): Boolean

   Tests whether the type represented by this manifest is a subtype of the type represented by `that' manifest, subject to the limitations described in the header.`

   Tests whether the type represented by this manifest is a subtype of the type represented by `that' manifest, subject to the limitations described in the header.`

   Definition Classes
     ClassManifest

5. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

6. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

7. #### def >:>(that: scala.reflect.ClassManifest[_]): Boolean

   Tests whether the type represented by this manifest is a supertype of the type represented by `that' manifest, subject to the limitations described in the header.`

   Tests whether the type represented by this manifest is a supertype of the type represented by `that' manifest, subject to the limitations described in the header.`

   Definition Classes
     ClassManifest

8. #### def argString: String

   Attributes
     protected
   Definition Classes
     ClassManifest

9. #### def arrayClass[T](tp: java.lang.Class[_]): Class[Array[T]]

   Attributes
     protected
   Definition Classes
     ClassManifest

10. #### def arrayManifest: Manifest[Array[T]]

    Definition Classes
      Manifest → ClassManifest

11. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

12. #### def canEqual(that: Any): Boolean

    A method that should be called from every well-designed equals method that is open to be overridden in a subclass.

    A method that should be called from every well-designed equals method that is open to be overridden in a subclass. See Programming in Scala, Chapter 28 for discussion and design.

    that

      the value being probed for possible equality

    returns

      true if this instance can possibly equal `that`, otherwise false

    Definition Classes
      Manifest → ClassManifest → Equals

13. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

14. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

15. #### def equals(that: Any): Boolean

    Note: testing for erasure here is important, as it is many times faster than <:< and rules out most comparisons.

    Note: testing for erasure here is important, as it is many times faster than <:< and rules out most comparisons.

    that

      the object to compare against this object for equality.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Manifest → ClassManifest → Equals → AnyRef → Any

16. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

17. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

18. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in Any.

    returns

      the hash code value for this object.

    Definition Classes
      Manifest → ClassManifest → AnyRef → Any

19. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

20. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

21. #### def newArray(len: Int): Array[T]

    Definition Classes
      ClassManifest

22. #### def newArray2(len: Int): Array[Array[T]]

    Definition Classes
      ClassManifest

23. #### def newArray3(len: Int): Array[Array[Array[T]]]

    Definition Classes
      ClassManifest

24. #### def newArray4(len: Int): Array[Array[Array[Array[T]]]]

    Definition Classes
      ClassManifest

25. #### def newArray5(len: Int): Array[Array[Array[Array[Array[T]]]]]

    Definition Classes
      ClassManifest

26. #### def newArrayBuilder(): ArrayBuilder[T]

    Definition Classes
      ClassManifest

27. #### def newWrappedArray(len: Int): WrappedArray[T]

    Definition Classes
      ClassManifest

28. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

29. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

30. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

31. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

32. #### def typeArguments: List[scala.reflect.Manifest[_]]

    Definition Classes
      Manifest → ClassManifest

33. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

34. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

35. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

### Inherited from ClassManifest[T]

### Inherited from Equals

### Inherited from OptManifest[T]

### Inherited from Serializable

### Inherited from AnyRef

### Inherited from Any